/**
  @file /ai/ai_makra.h
  @brief Header pro makra umele inteligence.
  
  Header, ktery definuje makra dulezita pouze pro praci modulu umele inteligence.
  
  @author PZ
  @version 0.1
*/

#ifndef __PETR_ZITA_AI_MAKRA__
#define __PETR_ZITA_AI_MAKRA__

#define PRIORITY_AI_FLOODFILL 1
#define PRIORITY_AI_ALLOC 1

/** Makro urcujici, zdali se ma volat tah umele inteligence - ma ciste ladici vyznam. */
#define AI_STRATEGIZER_ENABLED

/** Makro urcujici, zdali ma AI logovat sve akce. */
//#define AI_LOGGING

/** Makro definujici maximalni pocet hracu. */
#define MAX_PLAYERS 8

/** Makro urcujici validitu souradnic. */
#define INVALID_COORDS(c) (((c).x<0) || ((c).y<0))

/** Makro urcujici hodnotu nedostupneho hexu ci nemoznosti nalezt cestu. */
#define NOT_ACCESIBLE_DISPONIBILITY (-1)

/** Makro definujici datovy typ STL kontajneru se souradnicemi. */
#define COORDS_CONTAINER list

/** Makro definujici datovy typ kontajneru se souradnicemi. */
#define COORDS_ARRAY std::COORDS_CONTAINER<COORDS>

/** Makro definujici maximalni "delku" disponibility hrany ve strategickem grafu. */
#define MAX_THREAT_DISPONIBILITY 4

/** Makro definujici koeficient zmenseni pomeru cen statickych entit. */
#define PRICE_RATIO_REDUCE_FACTOR 2

/** Maximalni delka bufferu AI dat. */
#define MAX_AI_DATA_LENGTH 10000

/** Docasna delka bufferu AI pro ukladani jednotlivych polozek. */
#define TEMP_NUMBER_BUFFER_LENGTH 50

/** Makro udavajici, zda jednotka je pouzitelna pouze pro expanzi (napr. stavitel). */
#define EXPANSION_ONLY_UNIT_TYPE(ut) ((ut)==3)

/** Makro udavajici, zda jednotka je pouzitelna pouze pro utok (napr. mineri). */
#define ATTACK_ONLY_UNIT_TYPE(ut) ((ut)==13)

/** Makro udavajici, zda jednotka je pouzitelna pro braneni statickych entit. */
#define UNIT_FOR_DEFENCE_UNIT_TYPE(ut) (((ut)!=3) && ((ut)!=13))

/** Makro udavajici, zda jednotka je muze stavet (napr. stavitel). */
#define IS_BUILDER_UNIT_TYPE(ut) ((ut)==3)

/** Makro udavajici, zda jednotka muze byt pouzita pro pathfind analyzu. */
//#define UNIT_SUITABLE_FOR_PATHFIND_TESTING(ut) (((ut)!=3) && ((ut)!=4))
#define UNIT_SUITABLE_FOR_PATHFIND_TESTING(ut) (true)

/** Makro udavajici, zdali AI bude branit danou budovu (napr. most neni potreba). */
#define BUILDING_NEED_TO_DEFEND(bt) ((bt)!=6)

/** Makro udavajici, zdali AI bude cilene obsazovat danou budovu (napr. most neni potreba). */
#define BUILDING_TO_CONQUER(bt) ((bt)!=6)

/** Makro udavajici, zdali se ma budova pocitat do expanznich statistik. */
#define IS_PRODUCTION_BUILDING(bt) ((bt)!=6)

/** Makro udavajici, zdali planovane akce maji byt provadeny hned (true) nebo pozdeji jednorazove (false). */
#define PERFORM_IMMEDIATELY (true)

/** Makro s IDckem typu jednotky stavitele. */
#define BUILDER_UNIT_TYPE_ID 3

/** Makro s IDckem typu budovy mostu. */
#define BRIDGE_BUILDING_TYPE_ID 6

/** Makro s IDckem typu budovy, ze ktere bude AI planovat verbovani jednotek, pokud nema zadne budovy. */
#define FIRST_PRODUCTION_BUILDING_ID 2

/** Makro s hodnotou pro kriterium stavby mostu - uvadi, kolik kol chuze ma minimalne usetrit. */
#define BRIDGE_BUILDING_CRITERIUM 5

/** Makro s hodnotou pro kriterium stavby mostu - uvadi, kolik kol chuze ma minimalne usetrit. */
#define TERRAIN_FOR_BRIDGE_OUPUTS(tt) (tt==TT_PLAIN)

/** Makro s hodnotou pro kriterium stavby mostu - uvadi, kolik kol chuze ma minimalne usetrit. */
#define UNIT_OCCURENCE_BONUS 10

#endif

