/**
*******************************************************************************

  @file /common/compatibility.h
  @brief Makra ktera resi portaci


  @author Vajicek
  @version 0.1
 
******************************************************************************/
#ifndef COMPATIBILITY_H
#define COMPATIBILITY_H

#include <wchar.h>
#include <stdlib.h>

#include "config.h"

/** pouzivat vsnprintf, snprintf, vsnwprintf*/
#ifdef _MSC_VER
  #define snprintf _snprintf
  #define vsnprintf _vsnprintf
  #define vsnwprintf _vsnwprintf
#endif 

/** pouzivat snwprintf misto unixoveho swprintf */
#ifndef WIN32
  #define snwprintf swprintf
#else
  #define snwprintf _snwprintf
#endif

/** pouzivat vsnwprintf */
#ifndef WIN32
  #define vsnwprintf vswprintf
#else
  #define vsnwprintf _vsnwprintf
#endif

/** pouzivat stricmp */
#ifndef WIN32
  #define stricmp strcasecmp
  #define strnicmp strncasecmp
#endif

/** pouzivat __unlink */
#ifdef _K_EDITOR_
  #define __unlink unlink
#endif

/** pouzivat __unlink */
#ifdef WIN32
  #include <io.h>
  #define unlink _unlink
#else
  #include <unistd.h>
#endif


#endif
/*****************************************************************************/
