/**
******************************************************************************

  @file /common/priority.h
  @brief Definice priorit pro logovani

  Kazda priority povoluje nebo zamezuje logovani toho jevu, ktery je popsan
  v jeji definici
 
  @author Vta
  @version 1.0

******************************************************************************/
#ifndef _PRIORITY_
#define _PRIORITY_

//common

#define PRIORITY_THREAD 10                ///< Informace o spusteni/ukonceni vlakna
#define PRIORITY_FATAL 1000               ///< Fatalni chyba
#define PRIORITY_MUTEX 1                  ///< Zamknuti/odemknuti
#define PRIORITY_EXCETION_IN_THREAD 100   ///< Oznameni, ze doslo k chybe ve vlakne

// rm

#define PRIORITY_CONFIG 100               ///< Neexistuje/spatny config
#define PRIORITY_MISSING_FILE 100         ///< Chybi informacni soubor (napr. files.xml)
#define PRIORITY_MISSING_INFO 100         ///< Neexistuje dana polozka v informacnim souboru (napr. neexistujici jazykova sada v config.xml)
#define PRIORITY_MISSING_DATA 100         ///< Mam nactene vsechny soubory, ale samotne data nejsou k dispozici

#define PRIORITY_CREATING_DIRECTORY 100   ///< Informovani o vytvareni adresare, v pripade, ze byl nejaky smazan/neexistoval

#define PRIORITY_CONFIRM 1                ///< Potvrzeni, ze se RM/RMi znicil/vytvoril
#define PRIORITY_LOADING_QUEUE 1          ///< Oznamovani o prubehu nacitani fronty v RM
#define PRIORITY_WRONG_MAP 10             ///< Informace o souborech, ktere neobsahuji platnou mapu v adresari s mapami

#define PRIORITY_ERROR_IN_XML 10          ///< Zda se bude logovat chyba v XML souboru (zapsane v others.xml)
#define PRIORITY_DATA_WERE_TAKEN 10       ///< Zda hlasit, ze byl v nejakem RM volan get(DA<>)
#define PRIORITY_DATA_WERE_RETURNED 10    ///< Zda hlasit, ze byl v nejakem RM volan set(DA<>)
#define PRIORITY_DATA_WERE_NOT_RETURNED 10///< Zda hlasit, ze nebylo po get(DA<>) volano set(DA<>)

// net

#define PRIORITY_NEW_CONNECTION 10        ///< Informace o pripojeni klienta
#define PRIORITY_SENDING_DATA 2           ///< Informace o tom, ze se odesilaji data
#define PRIORITY_EMPTY_DATA 10            ///< Oznamovani, ze pres sit nebyly poslany zadne data
#define PRIORITY_WRONG_MESSAGE 10         ///< Oznameni v pripade prichodu spatne zpravy (spatny adresat nebo format)
#define PRIORITY_NET_NOT_INICIALIZED 10   ///< Oznamovani, ze sit nebyla jeste aktivovana
#define PRIORITY_NEW_MESSAGE 2            ///< Oznamovani, ze prisla nova zprava
#define PRIORITY_WARNING 10               ///< Vyjimky, jejichz vyskyt neni pro beh osudny
#define PRIORITY_NEW_SOCKET 10            ///< Informovani o vytvoreni noveho socketu

// xml

#define PRIORITY_XML 2                    ///< Vytvareni XML struktury
#define PRIORITY_PARSER 2                 ///< Problem pri zpracovani XML souboru
#define PRIORITY_DTD 2                    ///< Problem s DTD

// package

#define PRIORITY_WRONG_STRUCT 10          ///< Dotaz na atribut ktery neexistuje a modifikace korenoveho tagu 

// da

#define PRIORITY_DA 4                     ///< Oznamovani realokace pole
#define PRIORITY_DA_OUT_OF_RANGE 10       ///< Oznamovani pri pokusu o prekroceni maximalni velikosti pole

// komprese

#define PRIORITY_COMPRESSION 10           ///< Oznamovani chyb pri kompresi

#endif

/*****************************************************************************/
