/**
******************************************************************************

  @file /common/rm/rmxmlstruct.h
  @brief Popis struktur pro nacteni XML souboru
  
  @author Vta
  @version 1.0

******************************************************************************/
#ifndef _RMXmlStruct_
#define _RMXmlStruct_

#include "common/xml/xml.h"
#include "common/TCL/tcl_script.h"
#include "common/exc.h"
#include "world/plan/plan.h"

//using namespace World;

namespace rm
{

// oznaceni struktur
#define STRUCT_TCL 1     ///< Typ struktury TCL skript 
#define STRUCT_TERRAIN 2 ///< Typ struktury teren

// definice struktur a jejich prevodu
#define MAX_TYPE_LENGTH 10    ///< Delka nazvu nejdelsiho typu v TCL skriptu, vcetne koncove 0

/** Prevod XML do struktury pro TCL skripty */
void xmlToTcl(TCL_SCRIPT ** data,TXMLdata * xml,int id); 
/** Prevod struktury pro TCL skripty do XML */
void tclToXML(TXMLdata * xml,TCL_SCRIPT * data);
/** Uvolneni pameti struktury pro TCL skript */
void freeTclStruct(TCL_SCRIPT * data);

/** Prevod XML do struktury pro tereny */
void xmlToTerrain(World::TERRAIN ** data,TXMLdata * xml,int id); // data se budou alokovat
/** Prevod struktury pro tereny do XML */
void terrainToXML(TXMLdata * xml,World::TERRAIN * data);
/** Uvolneni pameti struktury pro teren */
void freeTerrainStruct(World::TERRAIN * data);

} // namespace 

#endif // ifndef
/*****************************************************************************/
