/** @file world/init.h

    Rutiny pro korektni inicializaci datovych struktur sdilenych mezi WORLDem 
    a dalsimi moduly, zejmena RM.

    @author Petr Wolf
*/

#ifndef WORLD_INIT_H
#define WORLD_INIT_H

#include "world/typedefs.h"
#include "world/players/player.h"

namespace World
{
    /// Implicitni inicializace (vynulovani hodnot) struktury BUILDING
    void BUILDING_Init(World::BUILDING * building);

    /// Implicitni inicializace (vynulovani hodnot) struktury LIVING_BUILDING
    void LIVING_BUILDING_Init(World::LIVING_BUILDING * living_building);

    /// Implicitni inicializace (vynulovani hodnot) struktury LIVING_UNIT
    void LIVING_UNIT_Init(World::LIVING_UNIT * living_unit);

    /// Implicitni inicializace (vynulovani hodnot) struktury UNIT
    void UNIT_Init(World::UNIT * unit);

    /// Implicitni inicializace (vynulovani hodnot) struktury UNIT_PROPERTY_BONUS
    void UNIT_PROPERTY_BONUS_Init(World::UNIT_PROPERTY_BONUS * bonus);

    /// Implicitni inicializace (vynulovani hodnot) struktury PLAYER
    void PLAYER_Init(World::PLAYER * player);

    /// Implicitni inicializace (vynulovani hodnot) struktury PLAYER_STATISTICS
    void PLAYER_STATISTICS_Init(World::PLAYER_STATISTICS * statistics);
};

#endif
